// Leds.c -   F4Discovery

#include "stm32f4xx.h"
#include "stm32f4xx_gpio.h"
#include "stm32f4xx_rcc.h"

#include "Leds.h"

#define LEDn                             4

#define LED4_PIN                         GPIO_Pin_12
#define LED4_GPIO_PORT                   GPIOD
#define LED4_GPIO_CLK                    RCC_AHB1Periph_GPIOD

#define LED3_PIN                         GPIO_Pin_13
#define LED3_GPIO_PORT                   GPIOD
#define LED3_GPIO_CLK                    RCC_AHB1Periph_GPIOD

#define LED5_PIN                         GPIO_Pin_14
#define LED5_GPIO_PORT                   GPIOD
#define LED5_GPIO_CLK                    RCC_AHB1Periph_GPIOD

#define LED6_PIN                         GPIO_Pin_15
#define LED6_GPIO_PORT                   GPIOD
#define LED6_GPIO_CLK                    RCC_AHB1Periph_GPIOD

static GPIO_TypeDef* GPIO_PORT[LEDn] = { LED4_GPIO_PORT, LED3_GPIO_PORT, LED5_GPIO_PORT, LED6_GPIO_PORT };
static const uint16_t GPIO_PIN[LEDn] = { LED4_PIN, LED3_PIN, LED5_PIN, LED6_PIN };

// Red  - PD14   - FSMC D0
// Blue - PD15	 - FSMC D1
// Green - PD12
// Orange - PD13
//  
void LedsInit ( void )
{
  //  LED

  RCC->AHB1ENR |= RCC_AHB1ENR_GPIODEN | RCC_AHB1ENR_GPIOAEN;
  GPIOD->MODER &= ~(GPIO_MODER_MODER12 | GPIO_MODER_MODER13 | GPIO_MODER_MODER14 | GPIO_MODER_MODER15);
  GPIOD->MODER |= GPIO_MODER_MODER12_0 | GPIO_MODER_MODER13_0 | GPIO_MODER_MODER14_0 | GPIO_MODER_MODER15_0;
  GPIOD->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR12 | GPIO_OSPEEDER_OSPEEDR13 | GPIO_OSPEEDER_OSPEEDR14 | GPIO_OSPEEDER_OSPEEDR15;
  GPIOA->MODER &= ~GPIO_MODER_MODER10;
  GPIOA->MODER |= GPIO_MODER_MODER10_0;

/*
  RCC->AHB1ENR |= RCC_AHB1ENR_GPIODEN ;
  GPIOD->MODER &= ~(GPIO_MODER_MODER14 | GPIO_MODER_MODER15);
  GPIOD->MODER |= GPIO_MODER_MODER14_0 | GPIO_MODER_MODER15_0;
  GPIOD->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR14 | GPIO_OSPEEDER_OSPEEDR15;
  GPIOA->MODER &= ~GPIO_MODER_MODER10;
  GPIOA->MODER |= GPIO_MODER_MODER10_0;
*/
} // LedsInit

//  
void STM_EVAL_LEDOn ( Led_TypeDef Led )
{
  GPIO_PORT[Led]->BSRRL = GPIO_PIN[Led];
} // STM_EVAL_LEDOn

//  
void STM_EVAL_LEDOff ( Led_TypeDef Led )
{
  GPIO_PORT[Led]->BSRRH = GPIO_PIN[Led];
} // STM_EVAL_LEDOff

void STM_EVAL_LEDToggle ( Led_TypeDef Led )
{
  GPIO_PORT[Led]->ODR ^= GPIO_PIN[Led];
} // STM_EVAL_LEDToggle
