#include <stdint.h>
#include <string.h>

#include "stm32f4xx.h"
#include "SSD1963.h"
#include "SSD1963_api.h"
#include "SSD1963_font.h"
#include "FSMC_LowLevel.h"


void LCD_Line(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1,uint16_t color)
{
 	uint16_t x,y;
 	uint16_t dx;// = abs(x1 - x0);
 	uint16_t dy;// = abs(y1 - y0);

	if(y0==y1)
	{
		if(x0<=x1)
		{
			x=x0;
		}
		else
		{
			x=x1;
			x1=x0;
		}
  		while(x <= x1)
  		{
   			LCD_PutPixel(x,y0,color);
   			x++;
  		}
  		return;
	}
	else if(y0>y1)
	{
		dy=y0-y1;
	}
	else
	{
		dy=y1-y0;
	}
 
 	if(x0==x1)
	{
		if(y0<=y1)
		{
			y=y0;
		}
		else
		{
			y=y1;
			y1=y0;
		}
  		while(y <= y1)
  		{
   			LCD_PutPixel(x0,y,color);
   			y++;
  		}
  		return;
	}
	else if(x0 > x1)
 	{
		dx=x0-x1;
  		x = x1;
  		x1 = x0;
  		y = y1;
  		y1 = y0;
 	}
 	else
 	{
		dx=x1-x0;
  		x = x0;
  		y = y0;
 	}

 	if(dx == dy)
 	{
  		while(x <= x1)
  		{

   			x++;
			if(y>y1)
			{
				y--;
			}
			else
			{
   				y++;
			}
   			LCD_PutPixel(x,y,color);
  		}
 	}
 	else
 	{
 		LCD_PutPixel(x, y, color);
  		if(y < y1)
  		{
   			if(dx > dy)
   			{
    			s16 p = dy * 2 - dx;
    			s16 twoDy = 2 * dy;
    			s16 twoDyMinusDx = 2 * (dy - dx);
    			while(x < x1)
    			{
     				x++;
     				if(p < 0)
     				{
      					p += twoDy;
     				}
     				else
     				{
      					y++;
      					p += twoDyMinusDx;
     				}
     				LCD_PutPixel(x, y,color);
    			}
   			}
   			else
   			{
    			s16 p = dx * 2 - dy;
    			s16 twoDx = 2 * dx;
    			s16 twoDxMinusDy = 2 * (dx - dy);
    			while(y < y1)
    			{
     				y++;
     				if(p < 0)
     				{
      					p += twoDx;
     				}
     				else
     				{
      					x++;
      					p+= twoDxMinusDy;
     				}
     				LCD_PutPixel(x, y, color);
    			}
   			}
  		}
  		else
  		{
   			if(dx > dy)
   			{
    			s16 p = dy * 2 - dx;
    			s16 twoDy = 2 * dy;
	    		s16 twoDyMinusDx = 2 * (dy - dx);
    			while(x < x1)
    			{
     				x++;
     				if(p < 0)
	     			{
    	  				p += twoDy;
     				}
     				else
     				{
      					y--;
	      				p += twoDyMinusDx;
    	 			}
     				LCD_PutPixel(x, y,color);
    			}
   			}
	   		else
   			{
    			s16 p = dx * 2 - dy;
    			s16 twoDx = 2 * dx;
	    		s16 twoDxMinusDy = 2 * (dx - dy);
    			while(y1 < y)
    			{
     				y--;
     				if(p < 0)
	     			{
    	  				p += twoDx;
     				}
     				else
     				{
      					x++;
	      				p+= twoDxMinusDy;
    	 			}
     				LCD_PutPixel(x, y,color);
    			}
   			}
  		}
 	}
}





void LCD_Circle(uint16_t cx,uint16_t cy,uint16_t r,uint16_t color,uint8_t fill)
{
	uint16_t x,y;
	s16 delta,tmp;
	x=0;
	y=r;
	delta=3-(r<<1);

	while(y>x)
	{
		if(fill)
		{
			LCD_Line(cx+x,cy+y,cx-x,cy+y,color);
			LCD_Line(cx+x,cy-y,cx-x,cy-y,color);
			LCD_Line(cx+y,cy+x,cx-y,cy+x,color);
			LCD_Line(cx+y,cy-x,cx-y,cy-x,color);
		}
		else
		{
			LCD_PutPixel(cx+x,cy+y,color);
			LCD_PutPixel(cx-x,cy+y,color);
			LCD_PutPixel(cx+x,cy-y,color);
			LCD_PutPixel(cx-x,cy-y,color);
			LCD_PutPixel(cx+y,cy+x,color);
			LCD_PutPixel(cx-y,cy+x,color);
			LCD_PutPixel(cx+y,cy-x,color);
			LCD_PutPixel(cx-y,cy-x,color);
		}
		x++;
		if(delta>=0)
		{
			y--;
			tmp=(x<<2);
			tmp-=(y<<2);
			delta+=(tmp+10);
		}
		else
		{
			delta+=((x<<2)+6);
		}
	}
}




/*********************************************************************
* Function: WORD LCD_Rectangle(SHORT left, SHORT top, SHORT right, SHORT bottom)
* Input: left,top - top left corner coordinates,
*        right,bottom - bottom right corner coordinates
* Output: For Blocking configuration:
*         - Always return 1.
* Overview: draws rectangle filled with current color
********************************************************************/

void LCD_Rectangle(uint16_t left, uint16_t top, uint16_t right, uint16_t bottom, uint16_t color, uint8_t fill)
{
	register uint16_t  x,y;


  if (!fill) {
    LCD_Line(left,top,left,bottom,color);
    LCD_Line(left,bottom,right,bottom,color);
    LCD_Line(right,bottom,right,top,color);
    LCD_Line(right,top,left,top,color);
  
  } else { // Filled Rectangle
	if(_clipRgn){
		if(left<_clipLeft)
			left = _clipLeft;
		if(right>_clipRight)
			right= _clipRight;
		if(top<_clipTop)
			top = _clipTop;
		if(bottom>_clipBottom)
			bottom = _clipBottom;
	}

	LCD_SetArea(left,top,right,bottom);
	LCD_WriteCommand(CMD_WR_MEMSTART);

	Clr_Cs;
	for(y=top; y<bottom+1; y++){
		for(x=left; x<right+1; x++){
          LCD_WriteData (color);
		}
	}
	Set_Cs;
  }
}

void LCD_Square(uint16_t x0, uint16_t y0, uint16_t width, uint16_t color,uint8_t fill)
{
	LCD_Rectangle(x0, y0, x0+width, y0+width, color,fill);
}


void LCD_DispPic_FullSize(const unsigned char *str)
{

	u32 temp;
	ColorTypeDef color;

	LCD_SetArea(0,0,GetMaxX(),GetMaxY());
	LCD_WriteCommand(CMD_WR_MEMSTART);

	Clr_Cs;
  
	for (temp = 2; temp < ((GetMaxX()+1)*(GetMaxY()+1))+2; temp++)
	{  
		color.uint8_t[1] =*(unsigned short *)(&str[ 2 * temp]);
		color.uint8_t[0]=*(unsigned short *)(&str[ 2 * temp+1]);
		//DataToWrite(i);
	
		LCD_WriteData(color.uint16_t);
	}
    Set_Cs;

//==============================  
}


void LCD_DispPic(uint16_t x0, uint16_t y0, const unsigned char *str)
{

	u32 temp;
    uint16_t x1;
    uint16_t y1;
    uint16_t imageWidth;
    uint16_t imageHeight;
    
    ColorTypeDef color;
    
    color.uint8_t[1] =*(unsigned short *)(&str[ 0]);
	color.uint8_t[0]=*(unsigned short *)(&str[ 1]);
    imageWidth = color.uint16_t;
    x1 = imageWidth-1 + x0;

    color.uint8_t[1] =*(unsigned short *)(&str[ 2]);
	color.uint8_t[0]=*(unsigned short *)(&str[ 3]);
    imageHeight = color.uint16_t;
    y1 = imageHeight-1 + y0;
    
	LCD_SetArea(x0,y0,x1,y1);
	LCD_WriteCommand(CMD_WR_MEMSTART);

	Clr_Cs;    

	for (temp = 2; temp < (imageWidth*imageHeight)+2; temp++)
	{  
		color.uint8_t[1] =*(unsigned short *)(&str[ 2 * temp]);
		color.uint8_t[0]=*(unsigned short *)(&str[ 2 * temp+1]);
		//DataToWrite(i);
	
		LCD_WriteData(color.uint16_t);
	}
    Set_Cs;

//==============================  
}


int power (int base, int n) {
    int     i, p;
    p = 1;
    for (i = 1; i <= n; ++i)
	p *= base;
    return p;
}

void LCD_PutChar(uint16_t x, uint16_t y, uint8_t Character, uint16_t ForeColor, uint16_t BackColor)
        {
        int row = 0;
        int column = 0;
        int offset = (Character - 32) * MyFont[0];
        
        LCD_SetArea(x, y, x+MyFont[1]-1, y+MyFont[2]-1);
        LCD_WriteCommand(CMD_WR_MEMSTART);
        Clr_Cs;        

            for (row = 0; row < MyFont[2]; row++)
            {
                for (column = 0; column < MyFont[1]; column++)
                {
                    if (row == 0)
                    {
                        if ((MyFont[2 * column + 1 +3+offset] & 1) > 0)
                        {
                            LCD_WriteData(ForeColor);
                        } else {
                            LCD_WriteData(BackColor);
                        }
                    }

                    if (row > 0 && row < 8)
                    {
                        if ((MyFont[2 * column + 1 + 3+offset] & (power(2, row))) > 0)  // Math.Pow = ^ (oplftet i)
                        {
                            LCD_WriteData(ForeColor);
                        } else {
                            LCD_WriteData(BackColor);
                        }
                    }

                    if (row == 8)
                    {
                        if ((MyFont[2 * column + 2 + 3+offset] & 1) > 0)
                        {
                            LCD_WriteData(ForeColor);
                        } else {
                            LCD_WriteData(BackColor);
                        }
                    }

                    if (row > 8 && row < 16)
                    {
                        if ((MyFont[2 * column + 2 + 3+offset] & (power(2, (row - 8)))) > 0)  // Math.Pow = ^ (oplftet i)
                        {
                            LCD_WriteData(ForeColor);
                        } else {
                            LCD_WriteData(BackColor);
                        }
                    }

                }
            }
        Set_Cs;
}    


void LCD_Num(int x, int y, long num, uint16_t ForeColor, uint16_t BackColor)
{
	char buf[25];
	char st[27];
	int i;
	uint8_t neg=0;
	int c=0;

	if (num==0)
	{
			st[0]=48;
			st[1]=0;
	}
	else
	{
		if (num<0)
		{
			neg=1;
			num=-num;
		}

		while (num>0)
		{
			buf[c]=48+(num % 10);
			c++;
			num=(num-(num % 10))/10;
		}
		buf[c]=0;

		if (neg)
		{
			st[0]=45;
		}


		for (i=0; i<c; i++)
		{
			st[i+neg]=buf[c-i-1];
		}
		st[c+neg]=0;

	}

	LCD_Text(x, y, st, ForeColor, BackColor); //LCD_Text(x, y, st, c+neg, ForeColor, BackColor);
}


void LCD_NumF(int x, int y, double num, uint8_t dec, uint16_t ForeColor, uint16_t BackColor)
{
	char buf[25];
	char st[27];
	uint8_t neg=0;
	int c=0, f=0, i, j;
	int c2, mult;
	unsigned long inum;

	if (dec<1)
	dec=1;
	if (dec>5)
	dec=5;

	if (num==0)
	{
			st[0]=48;
			st[1]=0;
			for (i=0; i<dec; i++)
				st[2+i]=48;
			st[2+dec]=0;
	}
	else
	{
		if (num<0)
		{
			neg=1;
			num=-num;
		}

		mult = 1;
		for (j = 0; j < dec; j++)
			mult = mult * 10;
		inum=(num*mult + 0.5);

		while (inum>0)
		{
			buf[c]=48+(inum % 10);
			c++;
			inum=(inum-(inum % 10))/10;
		}
		if ((num<1) & (num>0))
		{
			buf[c]=48;
			c++;
		}
		while (c<(dec+1))
		{
			buf[c]=48;
			c++;
		}
		buf[c]=0;

		if (neg)
		{
			st[0]=45;
		}

		if (0 >(c+neg-1))
		{
			for (i=0; i<(0-c-neg-1); i++)
			{
				st[i+neg]=0;
				f++;
			}
		}

		c2=neg;
		for (i=0; i<c; i++)
		{
			st[c2+f]=buf[c-i-1];
			c2++;
			if ((c-(c2-neg))==dec)
			{
				st[c2+f]=44;
				c2++;
			}
		}
		st[c2+f]=0;
	}

	LCD_Text(x, y, st, ForeColor, BackColor);
	//LCD_Text(x, y, st, c2+f, ForeColor, BackColor);
}




void LCD_Text(uint16_t x, uint16_t y, char *str, uint16_t ForeColor, uint16_t BackColor)
{
  uint8_t i;
  uint16_t len = strlen ( (const char*)str );
  
  for (i=0;i<len;i++)
  {
    LCD_PutChar((x+MyFont[1]*i),y,*str++,ForeColor,BackColor);
  }
}
