// SSD1963_Drv.c -   SSD1963 (FSMC)

typedef enum
{
	Orientation_Portrait,
	Orientation_Album		// Landscape
} TOrientation;

typedef enum
{
	LucidaConsole12pt		// Lucida Console 12pt
} TFont;

// RGB24 -> RGB565
uint16_t SSD1963_RGB565CONVERT ( uint8_t red, uint8_t green, uint8_t blue );

//  
void SSD1963_Init ( void );

//    ()
void SSD1963_SetOrient ( TOrientation orientation );

//    ()
TOrientation SSD1963_GetOrient ( void );

//  
void SSD1963_SetFont ( TFont fontId );

//   X
uint16_t SSD1963_GetMaxX ( void );

//   Y
uint16_t SSD1963_GetMaxY ( void );

void SSD1963_SetCursor ( uint16_t Xpos, uint16_t Ypos );

//  
//void SSD1963_SetDisplayWindow ( uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);

//  BMP
//void SSD1963_WriteBMP ( uint8_t Xpos, uint16_t Ypos, uint16_t Width, uint8_t Height, void *bitmap,
//		int rotate, bool isVertical );

//    
void SSD1963_FillScr ( uint16_t color );

//    
void SSD1963_FillRect ( uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color );

//    
void SSD1963_PutPixel ( uint16_t x, uint16_t y, uint16_t color );

//  
void SSD1963_drawLine ( int x1, int y1, int x2, int y2, uint16_t color );

//  
void SSD1963_DrawRect ( int x1, int y1, int x2, int y2, uint16_t color );

//////////////////////////////////////
//   

//  
void SSD1963_DrawString ( char* s, uint16_t x, uint16_t y, uint16_t color, uint16_t backColor, uint8_t isTransparent );

//   
uint8_t SSD1963_GetCharHight ( void );

//   
uint8_t SSD1963_DrawChar ( uint16_t x, uint16_t y, uint8_t c,
		uint16_t textColor, uint16_t backColor, uint8_t isTransparent );

//
//////////////////////////////////////
