#include <stdbool.h>
#include <string.h>
#include <math.h>

#include "stm32f4xx.h"
#include "stm32f4xx_rcc.h"

#include "SSD1963.h"
#include "System.h"
#include "Button.h"
#include "Leds.h"

//   (Button.c)
extern volatile uint8_t UserButtonPressed;

int main(void)
{
	RCC_ClocksTypeDef RCC_Clocks;
	uint16_t maxX, maxY, x, y;

	SystemInit();

	// SysTick end of count event each 1ms
	RCC_GetClocksFreq ( &RCC_Clocks );
	SysTick_Config ( RCC_Clocks.HCLK_Frequency / 1000 );

	// Initialize Leds mounted on STM32F4-Discovery board
	LedsInit ( );

    // Initialize User_Button on STM32F4-Discovery
    STM_EVAL_PBInit ( BUTTON_USER, BUTTON_MODE_EXTI );

/*
    SSD1963_Init ( );
    SSD1963_SetOrient ( Orientation_Album );

    //  
    SSD1963_FillScr ( SSD1963_RGB565CONVERT ( 0xFF, 0x00, 0x00 ) );
*/

    LCD_Initialize ( );
    LCD_Clear ( 0xFFFF );
    maxX = GetMaxX ( );
    maxY = GetMaxY ( );

    for ( x = 0; x < maxX; x ++ )
    	for ( y = 0; y < maxY; y ++ )
    		LCD_PutPixel ( x, y, 0x0000 );

    while (1)
    {

    } // while

} // main

